<?php
//
// Created on: <06-Oct-2002 16:01:10 amos>
//
// Copyright (C) 1999-2005 eZ systems as. All rights reserved.
//
// This source file is part of the eZ publish (tm) Open Source Content
// Management System.
//
// This file may be distributed and/or modified under the terms of the
// "GNU General Public License" version 2 as published by the Free
// Software Foundation and appearing in the file LICENSE included in
// the packaging of this file.
//
// Licencees holding a valid "eZ publish professional licence" version 2
// may use this file in accordance with the "eZ publish professional licence"
// version 2 Agreement provided with the Software.
//
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
// THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE.
//
// The "eZ publish professional licence" version 2 is available at
// http://ez.no/ez_publish/licences/professional/ and in the file
// PROFESSIONAL_LICENCE included in the packaging of this file.
// For pricing of this licence please contact us via e-mail to licence@ez.no.
// Further contact information is available at http://ez.no/company/contact/.
//
// The "GNU General Public License" (GPL) is available at
// http://www.gnu.org/copyleft/gpl.html.
//
// Contact licence@ez.no if any conditions of this licencing isn't clear to
// you.
//

/*! \file function_definition.php
*/

$FunctionList = array();

$FunctionList['object'] = array( 'name' => 'object',
                                 'operation_types' => array( 'read' ),
                                 'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                         'class' => 'eZContentFunctionCollection',
                                                         'method' => 'fetchContentObject' ),
                                 'parameter_type' => 'standard',
                                 'parameters' => array( array( 'name' => 'object_id',
                                                               'type' => 'integer',
                                                               'required' => true ) ) );
$FunctionList['version'] = array( 'name' => 'version',
                                  'operation_types' => array( 'read' ),
                                  'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                          'class' => 'eZContentFunctionCollection',
                                                          'method' => 'fetchContentVersion' ),
                                  'parameter_type' => 'standard',
                                  'parameters' => array( array( 'name' => 'object_id',
                                                                'type' => 'integer',
                                                                'required' => true ),
                                                         array( 'name' => 'version_id',
                                                                'type' => 'integer',
                                                                'default' => false,
                                                                'required' => true ) ) );
$FunctionList['node'] = array( 'name' => 'node',
                               'operation_types' => array( 'read' ),
                               'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                       'class' => 'eZContentFunctionCollection',
                                                       'method' => 'fetchContentNode' ),
                               'parameter_type' => 'standard',
                               'parameters' => array( array( 'name' => 'node_id',
                                                             'type' => 'integer',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'node_path',
                                                             'type' => 'string',
                                                             'required' => false,
                                                             'default' => false ) ) );
$FunctionList['locale_list'] = array( 'name' => 'locale_list',
                                      'operation_types' => array( 'read' ),
                                      'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                              'class' => 'eZContentFunctionCollection',
                                                              'method' => 'fetchLocaleList' ),
                                      'parameter_type' => 'standard',
                                      'parameters' => array( ) );
$FunctionList['translation_list'] = array( 'name' => 'translation_list',
                                           'operation_types' => array( 'read' ),
                                           'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                                   'class' => 'eZContentFunctionCollection',
                                                                   'method' => 'fetchTranslationList' ),
                                           'parameter_type' => 'standard',
                                           'parameters' => array( ) );
$FunctionList['non_translation_list'] = array( 'name' => 'object',
                                               'operation_types' => array( 'read' ),
                                               'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                                       'class' => 'eZContentFunctionCollection',
                                                                       'method' => 'fetchNonTranslationList' ),
                                               'parameter_type' => 'standard',
                                               'parameters' => array( array( 'name' => 'object_id',
                                                                             'type' => 'integer',
                                                                             'required' => true ),
                                                                      array( 'name' => 'version',
                                                                             'type' => 'integer',
                                                                             'required' => true ) ) );
$FunctionList['class'] = array( 'name' => 'object',
                                'operation_types' => array( 'read' ),
                                'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                        'class' => 'eZContentFunctionCollection',
                                                        'method' => 'fetchClass' ),
                                'parameter_type' => 'standard',
                                'parameters' => array( array( 'name' => 'class_id',
                                                              'type' => 'integer,string',
                                                              'required' => true ) ) );
$FunctionList['class_attribute_list'] = array( 'name' => 'object',
                                               'operation_types' => array( 'read' ),
                                               'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                                       'class' => 'eZContentFunctionCollection',
                                                                       'method' => 'fetchClassAttributeList' ),
                                               'parameter_type' => 'standard',
                                               'parameters' => array( array( 'name' => 'class_id',
                                                                             'type' => 'integer',
                                                                             'required' => true ),
                                                                      array( 'name' => 'version_id',
                                                                             'type' => 'integer',
                                                                             'required' => false,
                                                                             'default' => 0 ) ) );
$FunctionList['class_attribute'] = array( 'name' => 'object',
                                          'operation_types' => array( 'read' ),
                                          'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                                  'class' => 'eZContentFunctionCollection',
                                                                  'method' => 'fetchClassAttribute' ),
                                          'parameter_type' => 'standard',
                                          'parameters' => array( array( 'name' => 'attribute_id',
                                                                        'type' => 'integer',
                                                                        'required' => true ),
                                                                 array( 'name' => 'version_id',
                                                                        'type' => 'integer',
                                                                        'required' => false,
                                                                        'default' => 0 ) ) );
$FunctionList['calendar'] = array( 'name' => 'calendar',
                                   'operation_types' => array( 'read' ),
                                   'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                           'class' => 'eZContentFunctionCollection',
                                                           'method' => 'calendar' ),
                                   'parameter_type' => 'standard',
                                   'parameters' => array( array( 'name' => 'parent_node_id',
                                                                 'type' => 'integer',
                                                                 'required' => true ),
                                                          array( 'name' => 'offset',
                                                                 'type' => 'integer',
                                                                 'required' => false,
                                                                 'default' => false ),
                                                          array( 'name' => 'limit',
                                                                 'type' => 'integer',
                                                                 'required' => false,
                                                                 'default' => false ),
                                                          array( 'name' => 'depth',
                                                                 'type' => 'integer',
                                                                 'required' => false,
                                                                 'default' => 1 ),
                                                          array( 'name' => 'depth_operator',
                                                                 'type' => 'string',
                                                                 'required' => false,
                                                                 'default' => 'le' ),
                                                          array( 'name' => 'class_id',
                                                                 'type' => 'integer',
                                                                 'required' => false,
                                                                 'default' => false ),
                                                          array( 'name' => 'attribute_filter',
                                                                 'type' => 'mixed',
                                                                 'required' => false,
                                                                 'default' => false ),
                                                          array( 'name' => 'extended_attribute_filter',
                                                                 'type' => 'mixed',
                                                                 'required' => false,
                                                                 'default' => false ),
                                                          array( 'name' => 'class_filter_type',
                                                                 'type' => 'string',
                                                                 'required' => false,
                                                                 'default' => false ),
                                                          array( 'name' => 'class_filter_array',
                                                                 'type' => 'array',
                                                                 'required' => false,
                                                                 'default' => false ),
                                                          array( 'name' => 'group_by',
                                                                 'type' => 'array',
                                                                 'required' => false,
                                                                 'default' => false ),
                                                          array( 'name' => 'main_node_only',
                                                                 'type' => 'bool',
                                                                 'required' => false,
                                                                 'default' => false ),
                                                          array( 'name' => 'ignore_visibility',
                                                                 'type' => 'bool',
                                                                 'required' => false,
                                                                 'default' => false ),
                                                          array( 'name' => 'limitation',
                                                                 'type' => 'array',
                                                                 'required' => false,
                                                                 'default' => null ) ) );

$FunctionList['list'] = array( 'name' => 'tree',
                               'operation_types' => array( 'read' ),
                               'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                       'class' => 'eZContentFunctionCollection',
                                                       'method' => 'fetchObjectTree' ),
                               'parameter_type' => 'standard',
                               'parameters' => array( array( 'name' => 'parent_node_id',
                                                             'type' => 'integer',
                                                             'required' => true ),
                                                      array( 'name' => 'sort_by',
                                                             'type' => 'array',
                                                             'required' => false,
                                                             'default' => array() ),
                                                      array( 'name' => 'only_translated',
                                                             'type' => 'bool',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'language',
                                                             'type' => 'string',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'offset',
                                                             'type' => 'integer',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'limit',
                                                             'type' => 'integer',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'depth',
                                                             'type' => 'integer',
                                                             'required' => false,
                                                             'default' => 1 ),
                                                      array( 'name' => 'depth_operator',
                                                             'type' => 'string',
                                                             'required' => false,
                                                             'default' => 'le' ),
                                                      array( 'name' => 'class_id',
                                                             'type' => 'integer',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'attribute_filter',
                                                             'type' => 'mixed',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'extended_attribute_filter',
                                                             'type' => 'mixed',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'class_filter_type',
                                                             'type' => 'string',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'class_filter_array',
                                                             'type' => 'array',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'group_by',
                                                             'type' => 'array',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'main_node_only',
                                                             'type' => 'bool',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'ignore_visibility',
                                                             'type' => 'bool',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'limitation',
                                                             'type' => 'array',
                                                             'required' => false,
                                                             'default' => null ),
                                                      array( 'name' => 'as_object',
                                                             'type' => 'bool',
                                                             'required' => false,
                                                             'default' => null ) ) );
$FunctionList['list_count'] = array( 'name' => 'list_count',
                                     'operation_types' => array( 'read' ),
                                     'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                             'class' => 'eZContentFunctionCollection',
                                                             'method' => 'fetchObjectTreeCount' ),
                                     'parameter_type' => 'standard',
                                     'parameters' => array( array( 'name' => 'parent_node_id',
                                                                   'type' => 'integer',
                                                                   'required' => true ),
                                                            array( 'name' => 'class_filter_type',
                                                                   'type' => 'string',
                                                                   'required' => false,
                                                                   'default' => false ),
                                                            array( 'name' => 'class_filter_array',
                                                                   'type' => 'array',
                                                                   'required' => false,
                                                                   'default' => false ),
                                                            array( 'name' => 'attribute_filter',
                                                                   'type' => 'mixed',
                                                                   'required' => false,
                                                                   'default' => false ),
                                                            array( 'name' => 'depth',
                                                                   'type' => 'string',
                                                                   'required' => false,
                                                                   'default' => 1 ),
                                                            array( 'name' => 'depth_operator',
                                                                   'type' => 'string',
                                                                   'required' => false,
                                                                   'default' => 'le' ),
                                                            array( 'name' => 'ignore_visibility',
                                                                   'type' => 'bool',
                                                                   'required' => false,
                                                                   'default' => false ),
                                                            array( 'name' => 'limitation',
                                                                   'type' => 'array',
                                                                   'required' => false,
                                                                   'default' => null ),
                                                            array( 'name' => 'main_node_only',
                                                                   'type' => 'bool',
                                                                   'required' => false,
                                                                   'default' => false ) ) );
$FunctionList['tree'] = array( 'name' => 'tree',
                               'operation_types' => array( 'read' ),
                               'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                       'class' => 'eZContentFunctionCollection',
                                                       'method' => 'fetchObjectTree' ),
                               'parameter_type' => 'standard',
                               'parameters' => array( array( 'name' => 'parent_node_id',
                                                             'type' => 'integer',
                                                             'required' => true ),
                                                      array( 'name' => 'sort_by',
                                                             'type' => 'array',
                                                             'required' => false,
                                                             'default' => array() ),
                                                      array( 'name' => 'only_translated',
                                                             'type' => 'bool',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'language',
                                                             'type' => 'string',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'offset',
                                                             'type' => 'integer',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'limit',
                                                             'type' => 'integer',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'depth',
                                                             'type' => 'integer',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'depth_operator',
                                                             'type' => 'integer',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'class_id',
                                                             'type' => 'integer',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'attribute_filter',
                                                             'type' => 'mixed',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'extended_attribute_filter',
                                                             'type' => 'mixed',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'class_filter_type',
                                                             'type' => 'string',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'class_filter_array',
                                                             'type' => 'array',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'group_by',
                                                             'type' => 'array',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'main_node_only',
                                                             'type' => 'bool',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'ignore_visibility',
                                                             'type' => 'bool',
                                                             'required' => false,
                                                             'default' => false ),
                                                      array( 'name' => 'limitation',
                                                             'type' => 'array',
                                                             'required' => false,
                                                             'default' => null ),
                                                      array( 'name' => 'as_object',
                                                             'type' => 'bool',
                                                             'required' => false,
                                                             'default' => null ) ) );

$FunctionList['tree_count'] = array( 'name' => 'tree_count',
                                     'operation_types' => array( 'read' ),
                                     'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                             'class' => 'eZContentFunctionCollection',
                                                             'method' => 'fetchObjectTreeCount' ),
                                     'parameter_type' => 'standard',
                                     'parameters' => array( array( 'name' => 'parent_node_id',
                                                                   'type' => 'integer',
                                                                   'required' => true ),
                                                            array( 'name' => 'class_filter_type',
                                                                   'type' => 'string',
                                                                   'required' => false,
                                                                   'default' => false ),
                                                            array( 'name' => 'class_filter_array',
                                                                   'type' => 'array',
                                                                   'required' => false,
                                                                   'default' => false ),
                                                            array( 'name' => 'attribute_filter',
                                                                   'type' => 'mixed',
                                                                   'required' => false,
                                                                   'default' => false ),
                                                            array( 'name' => 'depth',
                                                                   'type' => 'string',
                                                                   'required' => false,
                                                                   'default' => false ),
                                                            array( 'name' => 'depth_operator',
                                                                   'type' => 'string',
                                                                   'required' => false,
                                                                   'default' => false ),
                                                            array( 'name' => 'ignore_visibility',
                                                                   'type' => 'bool',
                                                                   'required' => false,
                                                                   'default' => false ),
                                                            array( 'name' => 'limitation',
                                                                   'type' => 'array',
                                                                   'required' => false,
                                                                   'default' => null ),
                                                            array( 'name' => 'main_node_only',
                                                                   'type' => 'bool',
                                                                   'required' => false,
                                                                   'default' => false ) ) );


$FunctionList['search'] = array( 'name' => 'search',
                                 'operation_types' => array( 'read' ),
                                 'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                         'class' => 'eZContentFunctionCollection',
                                                         'method' => 'fetchContentSearch' ),
                                 'parameter_type' => 'standard',
                                 'parameters' => array( array( 'name' => 'text',
                                                               'type' => 'string',
                                                               'required' => true ),
                                                        array( 'name' => 'subtree_array',
                                                               'type' => 'array',
                                                               'default' => false,
                                                               'required' => false ),
                                                        array( 'name' => 'offset',
                                                               'type' => 'integer',
                                                               'required' => false,
                                                               'default' => false ),
                                                        array( 'name' => 'limit',
                                                               'type' => 'integer',
                                                               'required' => false,
                                                               'default' => false ),
                                                        array( 'name' => 'publish_timestamp',
                                                               'type' => 'mixed',
                                                               'required' => false,
                                                               'default' => false ),
                                                        array( 'name' => 'publish_date',
                                                               'type' => 'integer',
                                                               'required' => false,
                                                               'default' => false ),
                                                        array( 'name' => 'section_id',
                                                               'type' => 'integer',
                                                               'required' => false,
                                                               'default' => false ),
                                                        array( 'name' => 'class_id',
                                                               'type' => 'integer',
                                                               'required' => false,
                                                               'default' => false ),
                                                        array( 'name' => 'class_attribute_id',
                                                               'type' => 'integer',
                                                               'required' => false,
                                                               'default' => false ),
                                                        array( 'name' => 'sort_by',
                                                               'type' => 'mixed',
                                                               'required' => false,
                                                               'default' => false )) );

$FunctionList['trash_count'] = array( 'name' => 'trash_count',
                                      'operation_types' => array( 'read' ),
                                      'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                              'class' => 'eZContentFunctionCollection',
                                                              'method' => 'fetchTrashObjectCount' ),
                                      'parameter_type' => 'standard',
                                      'parameters' => array(  ) );

$FunctionList['trash_object_list'] = array( 'name' => 'trash_object_list',
                                            'operation_types' => array( 'read' ),
                                            'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                                    'class' => 'eZContentFunctionCollection',
                                                                    'method' => 'fetchTrashObjectList' ),
                                            'parameter_type' => 'standard',
                                            'parameters' => array( array( 'name' => 'offset',
                                                                          'type' => 'integer',
                                                                          'required' => false,
                                                                          'default' => false ),
                                                                   array( 'name' => 'limit',
                                                                          'type' => 'integer',
                                                                          'required' => false,
                                                                          'default' => false ) ) );

$FunctionList['draft_count'] = array( 'name' => 'draft_count',
                                      'operation_types' => array( 'read' ),
                                      'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                              'class' => 'eZContentFunctionCollection',
                                                              'method' => 'fetchDraftVersionCount' ),
                                      'parameter_type' => 'standard',
                                      'parameters' => array(  ) );

$FunctionList['draft_version_list'] = array( 'name' => 'draft_version_list',
                                             'operation_types' => array( 'read' ),
                                             'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                                     'class' => 'eZContentFunctionCollection',
                                                                     'method' => 'fetchDraftVersionList' ),
                                             'parameter_type' => 'standard',
                                             'parameters' => array( array( 'name' => 'offset',
                                                                           'type' => 'integer',
                                                                           'required' => false,
                                                                           'default' => false ),
                                                                    array( 'name' => 'limit',
                                                                           'type' => 'integer',
                                                                           'required' => false,
                                                                           'default' => false ) ) );

$FunctionList['pending_count'] = array( 'name' => 'pending_count',
                                        'operation_types' => array( 'read' ),
                                        'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                                'class' => 'eZContentFunctionCollection',
                                                                'method' => 'fetchPendingCount' ),
                                        'parameter_type' => 'standard',
                                        'parameters' => array(  ) );

$FunctionList['pending_list'] = array( 'name' => 'pending_list',
                                       'operation_types' => array( 'read' ),
                                       'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                               'class' => 'eZContentFunctionCollection',
                                                               'method' => 'fetchPendingList' ),
                                       'parameter_type' => 'standard',
                                       'parameters' => array( array( 'name' => 'offset',
                                                                     'type' => 'integer',
                                                                     'required' => false,
                                                                     'default' => false ),
                                                              array( 'name' => 'limit',
                                                                     'type' => 'integer',
                                                                     'required' => false,
                                                                     'default' => false ) ) );

$FunctionList['version_count'] = array( 'name' => 'version_count',
                                      'operation_types' => array( 'read' ),
                                      'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                              'class' => 'eZContentFunctionCollection',
                                                              'method' => 'fetchVersionCount' ),
                                      'parameter_type' => 'standard',
                                      'parameters' => array( array( 'name' => 'contentobject',
                                                                           'type' => 'object',
                                                                           'required' => true) ) );

$FunctionList['version_list'] = array( 'name' => 'version_list',
                                             'operation_types' => array( 'read' ),
                                             'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                                     'class' => 'eZContentFunctionCollection',
                                                                     'method' => 'fetchVersionList' ),
                                             'parameter_type' => 'standard',
                                             'parameters' => array( array( 'name' => 'contentobject',
                                                                           'type' => 'object',
                                                                           'required' => true),
                                                                    array( 'name' => 'offset',
                                                                           'type' => 'integer',
                                                                           'required' => false,
                                                                           'default' => false ),
                                                                    array( 'name' => 'limit',
                                                                           'type' => 'integer',
                                                                           'required' => false,
                                                                           'default' => false ) ) );



$FunctionList['can_instantiate_class_list'] = array( 'name' => 'can_instantiate_class_list',
                                                     'operation_types' => array( 'read' ),
                                                     'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                                             'class' => 'eZContentFunctionCollection',
                                                                             'method' => 'canInstantiateClassList' ),
                                                     'parameter_type' => 'standard',
                                                     'parameters' => array( array( 'name' => 'group_id',
                                                                                   'type' => 'array',
                                                                                   'required' => false,
                                                                                   'default' => 0 ),
                                                                            array( 'name' => 'parent_node',
                                                                                   'type' => 'object',
                                                                                   'required' => false,
                                                                                   'default' => 0 ),
                                                                            array( 'name' => 'filter_type',
                                                                                   'type' => 'string',
                                                                                   'required' => false,
                                                                                   'default' => 'include' ),
                                                                            array( 'name' => 'fetch_id',
                                                                                   'type' => 'string',
                                                                                   'required' => false,
                                                                                   'default' => false ),
                                                                            array( 'name' => 'as_object',
                                                                                   'type' => 'bool',
                                                                                   'required' => false,
                                                                                   'default' => true ) ) );

$FunctionList['can_instantiate_classes'] = array( 'name' => 'can_instantiate_classes',
                                                  'operation_types' => array( 'read' ),
                                                  'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                                          'class' => 'eZContentFunctionCollection',
                                                                          'method' => 'canInstantiateClasses' ),
                                                  'parameter_type' => 'standard',
                                                  'parameters' => array( array( 'name' => 'parent_node',
                                                                                'type' => 'object',
                                                                                'required' => false,
                                                                                'default' => 0 ) ) );
$FunctionList['contentobject_attributes'] = array( 'name' => 'contentobject_attributes',
                                                   'operation_types' => array( 'read' ),
                                                   'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                                           'class' => 'eZContentFunctionCollection',
                                                                           'method' => 'contentobjectAttributes' ),
                                                   'parameter_type' => 'standard',
                                                   'parameters' => array( array( 'name' => 'version',
                                                                                 'type' => 'object',
                                                                                 'required' => false,
                                                                                 'default' => 0 ),
                                                                          array( 'name' => 'language_code',
                                                                                 'type' => 'string',
                                                                                 'required' => false,
                                                                                 'default' => '' ) ) );

$FunctionList['bookmarks'] = array( 'name' => 'bookmarks',
                                    'operation_types' => array( 'read' ),
                                    'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                            'class' => 'eZContentFunctionCollection',
                                                            'method' => 'fetchBookmarks' ),
                                    'parameter_type' => 'standard',
                                    'parameters' => array( array( 'name' => 'offset',
                                                                  'type' => 'integer',
                                                                  'required' => false,
                                                                  'default' => false ),
                                                           array( 'name' => 'limit',
                                                                  'type' => 'integer',
                                                                  'required' => false,
                                                                  'default' => false ) ) );

$FunctionList['recent'] = array( 'name' => 'recent',
                                 'operation_types' => array( 'read' ),
                                 'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                         'class' => 'eZContentFunctionCollection',
                                                         'method' => 'fetchRecent' ),
                                 'parameter_type' => 'standard',
                                 'parameters' => array( ) );

$FunctionList['section_list'] = array( 'name' => 'section_list',
                                       'operation_types' => array( 'read' ),
                                       'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                               'class' => 'eZContentFunctionCollection',
                                                               'method' => 'fetchSectionList' ),
                                       'parameter_type' => 'standard',
                                       'parameters' => array( ) );

$FunctionList['tipafriend_top_list'] = array( 'name' => 'tipafriend_top_list',
                                              'operation_types' => array( 'read' ),
                                              'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                                      'class' => 'eZContentFunctionCollection',
                                                                      'method' => 'fetchTipafriendTopList' ),
                                              'parameter_type' => 'standard',
                                              'parameters' => array( array( 'name' => 'offset',
                                                                            'type' => 'integer',
                                                                            'required' => false,
                                                                            'default' => false ),
                                                                     array( 'name' => 'limit',
                                                                            'type' => 'integer',
                                                                            'required' => false,
                                                                            'default' => false ) ) );

$FunctionList['view_top_list'] = array( 'name' => 'view_top_list',
                                        'operation_types' => array( 'read' ),
                                        'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                                'class' => 'eZContentFunctionCollection',
                                                                'method' => 'fetchMostViewedTopList' ),
                                        'parameter_type' => 'standard',
                                        'parameters' => array( array( 'name' => 'class_id',
                                                                      'type' => 'integer',
                                                                      'required' => false,
                                                                      'default' => false ),
                                                               array( 'name' => 'section_id',
                                                                      'type' => 'integer',
                                                                      'required' => false,
                                                                      'default' => false ),
                                                               array( 'name' => 'offset',
                                                                      'type' => 'integer',
                                                                      'required' => false,
                                                                      'default' => false ),
                                                               array( 'name' => 'limit',
                                                                      'type' => 'integer',
                                                                      'required' => false,
                                                                      'default' => false ) ) );

$FunctionList['collected_info_count'] = array( 'name' => 'collected_info_count',
                                               'operation_types' => array( 'read' ),
                                               'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                                       'class' => 'eZContentFunctionCollection',
                                                                       'method' => 'fetchCollectedInfoCount' ),
                                               'parameter_type' => 'standard',
                                               'parameters' => array( array( 'name' => 'object_attribute_id',
                                                                             'type' => 'integer',
                                                                             'required' => false,
                                                                             'default' => false ),
                                                                      array( 'name' => 'object_id',
                                                                             'type' => 'integer',
                                                                             'required' => false,
                                                                             'default' => false ),
                                                                      array( 'name' => 'value',
                                                                             'type' => 'integer',
                                                                             'required' => false,
                                                                             'default' => false ) ) );

$FunctionList['collected_info_count_list'] = array( 'name' => 'collected_info_count_list',
                                               'operation_types' => array( 'read' ),
                                               'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                                       'class' => 'eZContentFunctionCollection',
                                                                       'method' => 'fetchCollectedInfoCountList' ),
                                               'parameter_type' => 'standard',
                                               'parameters' => array( array( 'name' => 'object_attribute_id',
                                                                             'type' => 'integer',
                                                                             'required' => true,
                                                                             'default' => false ) ) );


$FunctionList['collected_info_collection'] = array( 'name' => 'collected_info_collection',
                                                    'operation_types' => array( 'read' ),
                                                    'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                                            'class' => 'eZContentFunctionCollection',
                                                                            'method' => 'fetchCollectedInfoCollection' ),
                                                    'parameter_type' => 'standard',
                                                    'parameters' => array( array( 'name' => 'collection_id',
                                                                                  'type' => 'integer',
                                                                                  'required' => false,
                                                                                  'default' => false ),
                                                                           array( 'name' => 'contentobject_id',
                                                                                  'type' => 'integer',
                                                                                  'required' => false,
                                                                                  'default' => false ) ) );
$FunctionList['object_by_attribute'] = array( 'name' => 'object_by_attribute',
                                              'operation_types' => array( 'read' ),
                                              'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                                      'class' => 'eZContentFunctionCollection',
                                                                      'method' => 'fetchObjectByAttribute' ),
                                              'parameter_type' => 'standard',
                                              'parameters' => array( array( 'name' => 'identifier',
                                                                            'type' => 'string',
                                                                            'required' => true,
                                                                            'default' => false ) ) );

$FunctionList['object_count_by_user_id'] = array( 'name' => 'object_count_by_user_id',
                                                  'operation_types' => array( 'read' ),
                                                  'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                                      'class' => 'eZContentFunctionCollection',
                                                                      'method' => 'fetchObjectCountByUserID' ),
                                              'parameter_type' => 'standard',
                                              'parameters' => array( array( 'name' => 'class_id',
                                                                            'type' => 'integer',
                                                                            'required' => true,
                                                                            'default' => false ),
                                                                     array( 'name' => 'user_id',
                                                                            'type' => 'integer',
                                                                            'required' => true,
                                                                            'default' => false ) ) );

$FunctionList['same_classattribute_node'] = array( 'name' => 'same_classattribute_node',
                                     'operation_types' => array( 'read' ),
                                     'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                             'class' => 'eZContentFunctionCollection',
                                                             'method' => 'fetchSameClassAttributeNodeList' ),
                                     'parameter_type' => 'standard',
                                     'parameters' => array( array( 'name' => 'classattribute_id',
                                                                   'type' => 'integer',
                                                                   'required' => true ),
                                                            array( 'name' => 'value',
                                                                   'type' => 'mixed',
                                                                   'required' => true ),
                                                            array( 'name' => 'datatype',
                                                                   'type' => 'string',
                                                                   'required' => true ) ) );

$FunctionList['keyword'] = array( 'name' => 'keyword',
                                  'operation_types' => array( 'read' ),
                                  'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                          'class' => 'eZContentFunctionCollection',
                                                          'method' => 'fetchKeyword' ),
                                  'parameter_type' => 'standard',
                                  'parameters' => array( array( 'name' => 'alphabet',
                                                                'type' => 'string',
                                                                'required' => true ),
                                                         array( 'name' => 'classid',
                                                                'type' => 'integer',
                                                                'required' => false,
                                                                'default' => false ),
                                                         array(	'name' => 'offset',
                                                             	'type' => 'integer',
                                                             	'required' => false,
                                                             	'default' => false ),
                                                         array( 'name' => 'limit',
                                                                'type' => 'integer',
                                                                'required' => false,
                                                                'default' => false ) ) );

$FunctionList['keyword_count'] = array( 'name' => 'keyword_count',
                                        'operation_types' => array( 'read' ),
                                        'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                                'class' => 'eZContentFunctionCollection',
                                                                'method' => 'fetchKeywordCount' ),
                                        'parameter_type' => 'standard',
                                        'parameters' => array( array( 'name' => 'alphabet',
                                                                      'type' => 'string',
                                                                      'required' => true ),
                                                               array( 'name' => 'classid',
                                                                      'type' => 'integer',
                                                                      'required' => false,
                                                                      'default' => false ) ) );

$FunctionList['access'] = array( 'name' => 'access',
                                 'operation_types' => array( 'read' ),
                                 'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                         'class' => 'eZContentFunctionCollection',
                                                         'method' => 'checkAccess' ),
                                 'parameter_type' => 'standard',
                                 'parameters' => array( array( 'name' => 'access',
                                                               'type' => 'string',
                                                               'required' => true ),
                                                        array( 'name' => 'contentobject',
                                                               'type' => 'object', // eZContentObject or eZContentObjectTreeNode
                                                               'required' => true ),
                                                        array( 'name' => 'contentclass_id',
                                                               'type' => 'integer',
                                                               'required' => false,
                                                               'default' => false ),
                                                        array( 'name' => 'parent_contentclass_id',
                                                               'type' => 'integer',
                                                               'required' => false,
                                                               'default' => false ) ) );

// Fetches all navigation parts as an array
$FunctionList['navigation_parts'] = array( 'name' => 'navigation_parts',
                                           'operation_types' => array( 'read' ),
                                           'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                                   'class' => 'eZContentFunctionCollection',
                                                                   'method' => 'fetchNavigationParts' ),
                                           'parameter_type' => 'standard',
                                           'parameters' => array() );

// Fetches one navigation part by identifier
$FunctionList['navigation_part'] = array( 'name' => 'navigation_part',
                                          'operation_types' => array( 'read' ),
                                          'call_method' => array( 'include_file' => 'kernel/content/ezcontentfunctioncollection.php',
                                                                  'class' => 'eZContentFunctionCollection',
                                                                  'method' => 'fetchNavigationPart' ),
                                          'parameter_type' => 'standard',
                                          'parameters' => array( array( 'name' => 'identifier',
                                                                        'type' => 'string',
                                                                        'required' => true ) ) );
?>
